<template>
  <div style="display:none">
    <h1>PLANTILLA</h1>
    <p>Carga Masiva</p>
    <table id="template" summary="Carga masiva Cuidemonos" rules="groups" frame="hsides" border="1">
      <caption style="text-align: center;"><u style="font-weight: bold;">REGISTRO MASIVO DE ESPECIALISTAS AL SISTEMA CUIDÉMONOS</u></caption>
      <caption>&nbsp;</caption>
      <colgroup align="center" />
      <colgroup align="left" />
      <colgroup span="2" align="center" />
      <colgroup span="3" align="center" />
      <thead valign="top">
        <tr style="background-color: yellow;">
          <th scope="col">TIPO DE<br>DOCUMENTO</th>
          <th scope="col">NÚMERO DE<br>DOCUMENTO</th>
          <th scope="col">NOMBRES</th><th>APELLIDO<br>PATERNO</th>
          <th scope="col">APPELIDO<br>MATERNO</th>
          <th scope="col">CORREO</th><th>DOMICILIO</th>
          <th scope="col">FECHA DE<br>NACIMIENTO</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td class="select" style="border: solid black; width:100px">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
        <tr>
          <td class="select" style="border: solid black;">
            <select name="D1">
              <option value="dni">DNI</option>
              <option value="pasaporte">PASAPORTE</option>
              <option value="carnet">CARNET</option>
            </select>
          </td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;" />
          <td style="border: solid black;" />
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
          <td style="border: solid black;">&nbsp;</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script>
export default {
  name: 'TableToExcel',
  props: {
    download: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      uri: 'data:application/vnd.ms-excel;base64,',
      template: '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--><meta http-equiv="content-type" content="text/plain; charset=UTF-8"/></head><body><table>{table}</table></body></html>',
      base64(s) { return window.btoa(unescape(encodeURIComponent(s))); },
      format(s, c) { return s.replace(/{(\w+)}/g, function (m, p) { return c[p]; }); },
    };
  },
  watch: {
    download() {
      if (this.download) {
        this.tableToExcel('template', 'Carga Masiva');
      }
    },
  },
  methods: {
    tableToExcel(table, name) {
      if (!table.nodeType) {
        table = document.getElementById(table);
      }
      const ctx = { worksheet: name || 'Worksheet', table: table.innerHTML };
      window.location.href = this.uri + this.base64(this.format(this.template, ctx));
    },
  },
};
</script>
<style scoped>
table, th, td {
  border: black;
}
</style>
